<?php

global $cnf;
global $esqDB;

if( !is_array($esqDB) ) { $esqDB = array(); }
if( !is_array($esqDB['xcomun']) ) { $esqDB['xcomun'] = array(); }
if( !is_array($esqDB['xapito']) ) { $esqDB['xapito'] = array(); }

if(isset($cnf['dbschema']) AND $cnf['dbschema'] === true)
{
	$xap = "xapito.";
	$xcm = "xcomun.";
}
else
{
	$xap = "public.xap_";
	$xcm = "public.xcm_";
}

$esqDB['login'] = "'{$_SESSION['login']}'";
$esqDB['grupo'] = "{$_SESSION['cnf']['grupo_activo']}";

$esqDB['xapito']['acceso'] = "{$xap}acceso";

$esqDB['xcomun']['cnf_grupos'] 			= "{$xcm}cnf_grupos";
$esqDB['xcomun']['grupos'] 				= "{$xcm}grupos";
$esqDB['xcomun']['permisos'] 				= "{$xcm}permisos";
$esqDB['xcomun']['sesiones'] 				= "{$xcm}sesiones";
$esqDB['xcomun']['usuarios'] 				= "{$xcm}usuarios";
$esqDB['xcomun']['usuarios_grupos'] 	= "{$xcm}usuarios_grupos";
$esqDB['xcomun']['usuarios_permisos'] 	= "{$xcm}usuarios_permisos";
$esqDB['xcomun']['campos_db'] 			= "{$xcm}campos_db";
$esqDB['xcomun']['documentos_nv'] 		= "documentos_nv"; //"{$xcm}documentos_nv";
$esqDB['xcomun']['documentos'] 			= "{$prefXcomun}documentos";
$esqDB['xcomun']['grupos_permisos'] 	= "{$prefXcomun}grupos_permisos";

$esqDB['xcomun']['nuips_emails'] 		= "{$xcm}nuips_emails_v1";
$esqDB['xcomun']['usuarios_v1'] 			= "{$xcm}usuarios_v1";

//var_dump($esqDB);

function sql_cons_documentos($fun) {
 global $esqDB;
   switch($fun) {
      case '4': {
         return "SELECT number, string FROM {$esqDB['xcomun']['documentos_nv']}(?, ?, ?, ?); ";
      }
      break;
      case '5': {
         return "SELECT number, string, date FROM {$esqDB['xcomun']['documentos_nv']}(?, ?, ?, {$esqDB['grupo']}, ?); ";
      }
      break;
      case 'alterar': {
         return "UPDATE {$esqDB['xcomun']['documentos']} SET cons_doc=? WHERE id_doc=?; ";
      }
      break;
      case 'version': {
         return "v.110614.1";
      }
      break;
   }
}

function sql_xcm_usuarios($fun) {
	global $esqDB;
	switch($fun) {
	 case 'verifica_login_con_nivel': {
	 	return "SELECT (login), id_nivel_usuario, cant_sesiones_max, cant_sesiones, is_activo, id_nuip_serial, id_nuip
	               FROM {$esqDB['xcomun']['usuarios_v1']}
	               WHERE login  = ? AND passwd = ? ; ";
	 }
	 break;
   case 'verifica_login_sin_nivel': {
	 	return "SELECT (login), 2 AS id_nivel_usuario, cant_sesiones_max, cant_sesiones, is_activo, id_nuip_serial, id_nuip
	               FROM {$esqDB['xcomun']['usuarios_v1']}
	               WHERE login  = ? AND passwd = ? ; ";
	 }
	 break;
   case 'actualiza_sesiones': {
	 	return "UPDATE {$esqDB['xcomun']['usuarios']} SET cant_sesiones = ?
		                 WHERE login  = ?
						     AND passwd = ? ; ";
	 }
	 break;
	case 'inserta_usuario': {
		return "SELECT graba_xcm_usuario AS bresultado FROM graba_xcm_usuario(?::BIGINT, ?, ?, ?); ";
	} break;
	case 'actualiza_pasabordo': {
		return "SELECT graba_xcm_usuario_pasabordo AS bresultado FROM graba_xcm_usuario_pasabordo(?, ?, ?); ";
	} break;
	case 'version': {return "110804.1";}
  }
}

function sql_xcm_sesiones($fun = 'default')
{
	global $esqDB;
	switch($fun)
	{
		case 'default':
		{
		  return "SELECT login, fec_ingreso, ip, id_sesion
		  				FROM {$esqDB['xcomun']['sesiones']}
		  				WHERE login= ? ; ";
		}
		break;

		case 'guarda_login_semilla':
		{
		  return 'INSERT INTO public.xcm_sesiones ( "login", ip, semilla ) VALUES (?, ?, ?);';
		}
		break;

		case 'retorna_id_sesion':
		{
		  return "SELECT id_sesion
		  				FROM {$esqDB['xcomun']['sesiones']}
		  				WHERE login = ? AND ip = ? AND semilla = ? ; ";
		}
		break;

	}
}

function sql_xcm_usuariosgrupos($fun = 'default')
{
	global $esqDB;
	switch($fun)
	{
		case 'default':
		{
		  return "SELECT id_grupo
		           FROM {$esqDB['xcomun']['usuarios_grupos']}
		           WHERE login  = ? ; ";
		}
		break;
	}
}

function sql_xcm_grupos($fun = 'default')
{
	global $esqDB;
	switch($fun)
	{
		case 'default':
		{
		  return "SELECT nom_grupo
		               FROM {$esqDB['xcomun']['grupos']}
		               WHERE id_grupo IN (?); ";
		}
		break;
	}
}

function sql_xcm_cnf_grupos($fun = 'default')
{
	global $esqDB;
	switch($fun)
	{
		case 'default':
		{
		  return "SELECT nom_cnf, vr_cnf
		  				FROM {$esqDB['xcomun']['cnf_grupos']}
                  WHERE id_grupo IN (?); ";
		}
		break;
	}
}

function sql_xcm_nuips($fun = 'version') {
	global $esqDB;
	switch($fun) {
		case 'Sel_emails': {
			return "SELECT id_nuip_serial, id_nuip, nom_nuip, ape_nuip, email, id_nuip_email"
			. ", id_tipo_dir, nom_tipo_dir_es, abr_tipo_dir_es "
			. " FROM {$esqDB['xcomun']['nuips_emails']} WHERE id_nuip_serial = ?; ";
		} break;
		case 'version': {
			return "v.110809.1";
		}
		break;
	}
}

/*
 Afecta al formulario seg_permisos_grupos_sr.php
*/
/*
function sql_seg_permisos_grupo($fun)
{
	switch($fun)
	{
	 case 'carga_permisos_grupo':
	 	{
	 		return "SELECT id_permiso FROM public.xcm_grupos_permisos WHERE id_grupo = ?; ";
	 	}
	 	break;

	 case 'borra_permisos_grupo':
	 	{
	 		return "DELETE FROM public.xcm_grupos_permisos WHERE id_grupo = ?; ";
	 	}
	 	break;

	 case 'guarda_permisos_grupo':
	 	{
	 		return "INSERT INTO public.xcm_grupos_permisos(id_grupo
                     , id_permiso
                     , login_admin
                     ) VALUES (?, ?, ?); ";
	 	}
	 	break;

	}
}
*/
/*
 Afecta al formulario seg_usuarios_permisos_sr.php
*/
/*
function sql_seg_permisos_usurios($fun)
{
	switch($fun)
	{
	 case 'carga_permisos_usuario':
	 	{
	 		return "SELECT id_permiso FROM public.xcm_usuarios_permisos WHERE login = ?; ";
	 	}
	 	break;

	 case 'borra_permisos_usuario':
	 	{
	 		return "DELETE FROM public.xcm_usuarios_permisos WHERE login = ?; ";
	 	}
	 	break;

	 case 'guarda_permisos_usuario':
	 	{
	 		return "INSERT INTO public.xcm_usuarios_permisos(
	 				login
                    , id_permiso
                    , login_admin
                    ) VALUES (?, ?, ?); ";
	 	}
	 	break;

	 case 'oculta_permisos':
	 	{
	 		return "SELECT id_permiso
			FROM public.xcm_usuarios_grupos u
			JOIN  public.xcm_grupos_permisos g ON u.id_grupo=g.id_grupo AND u.login=?;";
	 	}
	 	break;

	}
}
*/
/*
 Afecta al formulario seg_cambia_passwd_sr.php
*/
/*
function sql_seg_cambia_passwd($fun)
{
	switch($fun)
	{
	 case 'cambia_datos_0':
	 	{
	 		return "UPDATE public.xcm_usuarios SET
        		passwd = ?
        		WHERE login = ?";
	 	}
	 	break;
	}

}
*/
/*
 Afecta al formulario seg_usuario_sr.php
*/
/*
function sql_seg_usuario($fun)
{
	switch($fun)
	{
	 case 'carga_datos_0':
	 	{
	 		return "SELECT *  from public.xcm_usuarios
			WHERE   login = ?";
	 	}
	 	break;
	 case 'carga_datos_1':
	 	{
	 		return "SELECT id_nuip_serial
     			, nom_nuip
     			, ape_nuip
     			, id_sexo
     			, fec_nacimiento::DATE
     			from public.xcm_nuips
			WHERE   id_nuip = ?";
	 	}
	 	break;
	 case 'carga_datos_2':
	 	{
	 		return "SELECT
     			id_nuip_serial
     			, is_activo
     			from public.xcm_usuarios
		 	WHERE   login = ?";
	 	}
	 	break;
	 case 'retorna_datos_0':
	 	{
	 		return "SELECT id_nuip_serial FROM public.xcm_nuips
					WHERE
      			id_nuip =?
					AND nom_nuip=?;";
	 	}
	 	break;
	 case 'graba_datos_0':
	 	{
	 		return "INSERT INTO public.xcm_nuips(
      			id_nuip,
      			nom_nuip,
      			ape_nuip,
      			fec_nacimiento,
      			id_sexo
      			) VALUES (?, ?, ?, ?, ?); ";
	 	}
	 	break;
	 case 'graba_datos_1':
	 	{
	 		return "INSERT INTO public.xcm_nuips_grupos(
      			id_nuip_serial,
      			id_grupo
      			) VALUES (?, ?); ";
	 	}
	 	break;
	 case 'graba_datos_2':
	 	{
	 		return "INSERT INTO public.xcm_nuips_emails(
      			id_nuip_serial,
      			id_tipo_dir,
     			 email
      			) VALUES (?, ?, ?); ";
	 	}
	 	break;
	 case 'graba_datos_3':
	 	{
	 		return "INSERT INTO public.xcm_nuips_tels(
      			id_nuip_serial,
      			id_tipo_tel,
      			tel
      			) VALUES (?, ?, ?); ";
	 	}
	 	break;
	 case 'graba_datos_4':
	 	{
	 		return "INSERT INTO public.xcm_usuarios(
     			id_nuip_serial,
     			is_activo,
     			login,
     			passwd,
     			id_nivel_usuario
     			) VALUES (?, ?, ?, ?, ?); ";
	 	}
	 	break;

	 case 'borra_datos':
	 	{
	 		return "DELETE FROM public.xcm_usuarios WHERE login = ?; ";
	 	}
	 	break;

	}

}
*/
/*
 Afecta al formulario seg_nuips_sr.php
*/
/*
function sql_seg_nuips($fun)
{
	switch($fun)
	{
		case 'retorna_datos_0':
			{
				return "SELECT id_nuip_serial FROM public.xcm_nuips
					WHERE
						id_nuip = ?
						AND digito_verif =?
						AND id_tipo_nuip = ?
						AND nom_nuip = ?
						AND ape_nuip = ?
						AND id_titulo_nuip = ?
						AND id_sexo = ?
						AND fec_nacimiento = ?
						AND nom_empresa = ?
						AND nom_contacto = ?
						AND notas = ? ; ";
			}
			break;
		case 'graba_datos_0':
			{
				return "INSERT INTO public.xcm_nuips(
			id_nuip
			, digito_verif
			, id_tipo_nuip
			, nom_nuip
			, ape_nuip
			, id_titulo_nuip
			, id_sexo
			, fec_nacimiento
			, nom_empresa
			, nom_contacto
			, notas
			) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?); ";
			}
			break;
		case 'graba_datos_1':
			{
				return "INSERT INTO public.xcm_nuips_grupos(
      			id_nuip_serial,
      			id_grupo
      			) VALUES (?, ?); ";
			}
			break;
		case 'graba_datos_2':
			{
				return "INSERT INTO public.xcm_nuips_emails(
      			id_nuip_serial,
      			id_tipo_dir,
      			email
      			) VALUES (?, ?, ?); ";
			}
			break;
		case 'graba_datos_3':
			{
				return "INSERT INTO public.xcm_nuips_tels(
      			id_nuip_serial,
      			id_tipo_tel,
      			tel
      			) VALUES (?, ?, ?); ";
			}
			break;
		case 'graba_datos_4':
			{
				return "INSERT INTO public.xcm_nuips_dirs(
      			id_nuip_serial,
      			id_tipo_dir,
      			dir
      			) VALUES (?, ?, ?); ";
			}
			break;
			///////////////////////////////////////////////////////
		case 'actualiza_datos_0':
			{
				return "UPDATE public.xcm_nuips_emails
			SET id_tipo_dir=?
			, email=?
			WHERE id_nuip_email=?; ";
			}
			break;
		case 'actualiza_datos_1':
			{
				return "UPDATE public.xcm_nuips_tels
			SET id_tipo_tel=?
			, tel=?
			WHERE id_nuip_tel=?; ";
			}
			break;
		case 'actualiza_datos_2':
			{
				return "UPDATE public.xcm_nuips_dirs
			SET id_tipo_dir=?
			, dir=?
			WHERE id_nuip_dir=?; ";
			}
			break;
		case 'actualiza_datos_3':
			{
				return "UPDATE public.xcm_nuips
			SET id_nuip=?
			, digito_verif=?
			, id_tipo_nuip=?
			, nom_nuip=?
			, ape_nuip=?
			, id_titulo_nuip=?
			, id_sexo=?
			, fec_nacimiento=?
			, nom_empresa=?
			, nom_contacto=?
			, notas=?
			WHERE id_nuip_serial=?;";
			}
			break;
		case 'actualiza_datos_4':
			{
				return "UPDATE public.xcm_nuips_grupos
			SET id_grupo=?
			WHERE id_nuip_serial=?;";
			}
			break;
			////////////////////////////////////////////////////
		case 'borra_datos_0':
			{
				return "DELETE FROM public.xcm_nuips_emails WHERE id_nuip_email=?; ";
			}
			break;
		case 'borra_datos_1':
			{
				return "DELETE FROM public.xcm_nuips_tels WHERE id_nuip_tel=?; ";
			}
			break;
		case 'borra_datos_2':
			{
				return "DELETE FROM public.xcm_nuips_dirs WHERE id_nuip_dir=?; ";
			}
			break;
		case 'borra_datos_3':
			{
				return "DELETE FROM public.xcm_nuips_emails WHERE id_nuip_serial=?; ";
			}
			break;
		case 'borra_datos_4':
			{
				return "DELETE FROM public.xcm_nuips_tels WHERE id_nuip_serial=?; ";
			}
			break;
		case 'borra_datos_5':
			{
				return "DELETE FROM public.xcm_nuips_dirs WHERE id_nuip_serial=?; ";
			}
			break;
		case 'borra_datos_6':
			{
				return "DELETE FROM public.xcm_nuips WHERE id_nuip_serial=?; ";
			}
			break;
		case 'borra_datos_7':
			{
				return "DELETE FROM public.xcm_nuips_grupos WHERE id_nuip_serial=?; ";
			}
			break;
	}
}
*/
?>
